/*
  IntelĂ̂𒼂vO Ver.1.05
  
  Ver.1.00 Ƃ肠
  Ver.1.01 ŏ1񂾂肷悤ɂ()
  Ver.1.02 8bytěǉ
  Ver.1.03 8byteWindowsΉ(_int64)
  Ver.1.04 S void *(signed/unsigned̋ʂȂ)
  Ver.1.05 int8,int16,int32,int64Ή
  
  ŋ߂̓gGfBAƂď̂̕ʓIH
  LSB first = Little Endian
  LSB last = Big Endian
*/
#include <stdio.h>
#include <stdlib.h>

#include "s_value.h"
#include "lsbfirst.h"

static int lsb_first_flag = 255;
/*
  255      : ܂fĂȂ
  1(TRUE)  : Intel݂
  0(FALSE) : Ⴄ݂
*/

int is_lsb_first(void)
{
  union lsb_first_short test;
  
  if(lsb_first_flag == 255)
  {
    test.data8[1] = 0;
    test.data8[0] = 1;
    
    switch(test.data16)
    {
    case 1:
      lsb_first_flag = 1;
      break;
    case 256:
      lsb_first_flag = 0;
      break;
    default:
      fprintf(stderr, "lsbfirst : Internal error!!!\n");
      exit(2);
    }
  }
  return(lsb_first_flag);
}

void change_lsb_first_16(void *data)
{
  union lsb_first_short *d;
  int8 dd;
  d =(union lsb_first_short *) data;
  
  dd = d->data8[1];
  d->data8[1] = d->data8[0];
  d->data8[0] = dd;
}

void change_lsb_first_32(void *data)
{
  union lsb_first_long *d;
  int8 dd;
  
  d =(union lsb_first_long *) data;
  
  dd = d->data8[3];
  d->data8[3] = d->data8[0];
  d->data8[0] = dd;
  
  dd = d->data8[2];
  d->data8[2] = d->data8[1];
  d->data8[1] = dd;
}

void change_lsb_first_64(void *data)
{
  union lsb_first_long_long *d;
  int8 dd;
  
  d =(union lsb_first_long_long *) data;
  
  dd = d->data8[7];
  d->data8[7] = d->data8[0];
  d->data8[0] = dd;
  
  dd = d->data8[6];
  d->data8[6] = d->data8[1];
  d->data8[1] = dd;
  
  dd = d->data8[5];
  d->data8[5] = d->data8[2];
  d->data8[2] = dd;
  
  dd = d->data8[4];
  d->data8[4] = d->data8[3];
  d->data8[3] = dd;
}
