#ifndef _LSB_FIRST_H_
#define _LSB_FIRST_H_

#include "s_value.h"

union lsb_first_short
{
  int8 data8[2];
  int16 data16;
};

union lsb_first_long
{
  int8 data8[4];
  int16 data16[2];
  int32 data32;
};

union lsb_first_long_long
{
  int8 data8[8];
  int16 data16[4];
  int32 data32[2];
  int64 data64;
};

int is_lsb_first(void);
void change_lsb_first_16(void *data);	// int16
void change_lsb_first_32(void *data);	// int32
void change_lsb_first_64(void *data);	// int64

#endif
// _LSB_FIRST_H_
