/*
  s_setconsoletitle.f EBhẼ^CgύX Ver.1.02
  
  vs_windows.h

gF
#include "s_setconsoletitle.f"

int main(int argc,char *argv)
{
  s_setconsoletitle(argc,argv);
  
}
  
  Ver.1.00 2015/04/28 Ƃ肠쐬AWindowsp
  Ver.1.01 2018/08/30 s_windows.hΉ
  Ver.1.02 2019/03/26 unixΉ(V[PXɂ)
*/

#ifndef __W_CONSOLETITLE_F__
#define __W_CONSOLETITLE_F__

#include "s_windows.h"
#include <string.h>
#ifdef __windows__
#include <windows.h>
#else
#include <stdio.h>
#include <stdlib.h>
#endif

// strcat_sΉ(ʓIɃG[)
#ifndef __windows__
#define strcat_s(s,len,append)	strcat(s,append)
#endif

static char *s_old_consoletitle = NULL;

void s_restoreconsoletitle(void)
{
  if(s_old_consoletitle != NULL)
  {
#ifdef __windows__
    SetConsoleTitleA(s_old_consoletitle);
#else
    printf("\033[23;2t");
    fflush(stdout);
#endif
    free(s_old_consoletitle);
    s_old_consoletitle = NULL;
  }
}

void s_setconsoletitle(int argc,char *argv[])
{
  int i,len;
  char *buf;

  if(s_old_consoletitle == NULL)
  {
#ifdef __windows__
    buf = calloc(1,MAX_PATH);
    if(buf != NULL)
    {
      if( GetConsoleTitleA(buf, MAX_PATH) )
      {
	s_old_consoletitle = buf;
	buf = NULL;
      }
    }
    if(buf != NULL) free(buf);
#else
    printf("\033[22;2t");
    s_old_consoletitle = calloc(1,1);
    *s_old_consoletitle = '\0';
#endif
  }
  
  len = argc; // 󔒂̐\0̕ɓĂ
  for(i=0;i<argc;i++)
  {
    len += (int)strlen(argv[i]);
  }
  buf = calloc(len,sizeof(char));
  
  buf[0] = '\0';
  for(i=0;i<argc;i++)
  {
    if(i != 0)
    {
      strcat_s(buf,len," ");
    }
    strcat_s(buf,len,argv[i]);
  }
#ifdef __windows__
  SetConsoleTitleA(buf);
#else
  printf("\033]0;%s\007",buf);
  fflush(stdout);
#endif
  free(buf);
  return;
}
#endif
