char M_TITLE[] = "Saibara's composite image program for ism Ver.1.00c\n";
char M_HELP[] = "composite_ism.exe <input1 id> <x> <y> <input2 id> <output id>\n";
/*
  ismf[^Ԃŉ摜

  ӓ_F{Iinput1̉摜TCYɑSč킹Binput2,outputTCYłȂ΂ȂȂB
*/
#define DEF_INPUTID	"ism_in"
#define DEF_INPUTID2	"ism_in2"
#define DEF_OUTPUTID	"ism_out"
#define DEF_XSIZE	0
#define DEF_YSIZE	0

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include "s_sharemem.h"
#include "ism_data.h"
#include "s_malloc.h"

#include "msleep.f"
#include "checksec.f"
#include "s_setconsoletitle.f"

// 摜{̂main_process.cŒ`
// ł͐錾̂
void change_data(unsigned char *buf, int size, int mx, int my, unsigned char *buf2);

// C֐
int main(int argc, char *argv[])
{
  char *inid1, *inid2, *outid;
  char *buf, *buf2;
  int x, y, size;
  ism_data *ism_in1, *ism_in2, *ism_out;
  ism_head *ismh_in1, *ismh_in2;
  int count;
  ism_time lasttime1, lasttime2;
  int flag;

  s_setconsoletitle(argc, argv);
  printf(M_TITLE);
  if (argc == 1)
  {
    printf(M_HELP);
    exit(1);
  }

  inid1 = DEF_INPUTID;
  inid2 = DEF_INPUTID2;
  outid = DEF_OUTPUTID;
  x = DEF_XSIZE;
  y = DEF_YSIZE;

  if (argc > 1) { inid1 = argv[1]; argc--; argv++; }
  if (argc > 1) { x = atoi(argv[1]); argc--; argv++; }
  if (argc > 1) { y = atoi(argv[1]); argc--; argv++; }
  if (argc > 1) { inid2 = argv[1]; argc--; argv++; }
  if (argc > 1) { outid = argv[1]; argc--; argv++; }

  printf("Processing ism ID '%s' '%s' -> '%s'\n", inid1, inid2, outid);
  printf("Image size : %d %d\n", x, y);

  // ism1m
  printf("Open Shared memory Input1\n");
  ism_in1 = ism_alloc_image_shared_memory_rgb(inid1, x, y);
  if (ism_in1 == NULL)
  {
    printf("Can't open input share memory '%s'\n", inid1);
    exit(1);
  }

  // ߂ē͉摜TCYl
  ismh_in1 = ism_get_head(ism_in1);
  x = ism_head_get_width(ismh_in1);
  y = ism_head_get_height(ismh_in1);
  printf("Image size : %d %d\n", x, y);

  // ism2m
  printf("Open Shared memory Input2\n");
  ism_in2 = ism_alloc_image_shared_memory_rgb(inid2, x, y);
  if (ism_in2 == NULL)
  {
    printf("Can't open input share memory '%s'\n", inid2);
    exit(1);
  }
  ismh_in2 = ism_get_head(ism_in2);

  // oismm
  printf("Open Shared memory Output\n");
  ism_out = ism_alloc_image_shared_memory_rgb(outid, x, y);
  if (ism_out == NULL)
  {
    printf("Can't open share memory\n");
    exit(1);
  }

  // obt@m
  size = x * y * 3;
  buf = xalloc(char, size);
  if (buf == NULL)
  {
    printf("Can't allocate buffer memory\n");
    exit(1);
  }
  buf2 = xalloc(char, size);
  if (buf == NULL)
  {
    printf("Can't allocate buffer memory 2\n");
    exit(1);
  }

  count = 0;
  ism_time_init(&lasttime1);
  ism_time_init(&lasttime2);
  printf("Start processing.\n");
  while (1)
  {
    flag = 0;
    if (ism_head_is_refreshed(ismh_in1, &lasttime1))
    {
      ism_head_get_lasttime(ismh_in1, &lasttime1);
      flag++;
    }
    if (ism_head_is_refreshed(ismh_in2, &lasttime2))
    {
      ism_head_get_lasttime(ismh_in2, &lasttime2);
      flag += 2;
    }
    if (flag > 0)
    {
      ism_copy_data(buf, ism_in1);
      ism_copy_data(buf2, ism_in2);
      change_data(buf, size, x, y, buf2);
      ism_put_data(ism_out, buf, size);
      ism_update_time_now(ism_out);
      count++;
    }
    else
    {
      msleep(ISM_WAIT_UPDATE_MSEC);
    }
    if (check_sec())
    {
      printf("%d image processed.\n", count);
      count = 0;
    }
  }
  ism_free_image_shared_memory(ism_in1);
  ism_free_image_shared_memory(ism_in2);
  ism_free_image_shared_memory(ism_out);
}
