/*
  Images in Shared Memory pTu[` Ver.1.07f
  
  v s_windows,s_sharemem,s_malloc,s_value,print_error,msleep
  
  Ήism_head.h Ver.1.02
  
  `Ă֐
  ism_*_from_(ssm,id)	ssm_dataΏۂƂismf[^p֐
  ism_head_*	ism_headΏۂƂ֐BقڑSɓism_*}N`
  ism_time_*	ism_time֌W̊֐Bقs_timeƓe
  ism_*		ism_dataΏۂƂ֐
  
  Ver.1.00 2011/10/11 Ƃ肠Windowsłō쐬,֐Sism_œ
  Ver.1.01 2011/11/01 print_errorΉ
  Ver.1.02 2011/11/22 \[XAunixpAmۃTCY0x0w莞̋ύX
  Ver.1.03 2012/10/03 ism_copy_data(),ism_copy_data_top()ǉ
  Ver.1.04 2012/10/25 ism_data.h Ver.1.01ɑΉ,ism_ssm_֐̐
  Ver.1.05 2012/12/06 ism_head_get_lasttime,ism_head_is_refreshed֐̒ǉ
  Ver.1.06 2015/05/21 ism_head_update_datasize_timeǉ,_now֘A𐮗
  Ver.1.07 2018/12/25 ism_head.h Ver.1.03ɑΉ,_fast֐̔p~(ɂȂ)
*/
// ism_dataXṼEFCg(P:~b)
#define WAIT_ISM_UPDATE		5
// 傫ƕׂႭȂ邪Aism_head_wait_refresh()݂̔ȂB
// u5v̎wł60fps(16.67~bԊu)炢܂ŒǏ]łH
#include "s_windows.h"

#include <stdio.h>
#include <stdlib.h>
#ifdef __windows__
#include <windows.h>
#else
#include <unistd.h>
#include <sys/time.h>
#endif

#include "ism_data.h"
#include "s_sharemem.h"
#include "s_malloc.h"
#include "print_error.h"

#include "msleep.f"

// ismňFOURCC̈ꗗ\
// enum ISM_* ̕тɍ킹
uint32 ism_fourcc[ISM_MAX + 1] =
{
 0x00000000,	// ISM_RGB
 0xffffffff
};	// ISM_MAX

// ssm_dataΏۂƂ֐Q
// ism_headւ̃|C^ lBIDƃo[WԍmFĂB
int ism_head_is_image_shared_memory(ism_head *ismh)
{
  if (ismh == NULL) return(FALSE);
  // o[W͏ʉʑ݂̌݊ڎw߃m[`FbNƂ
  return(ismh->ism_magic == ISM_ID_MAGIC);
}

// ism̃o[W擾B(l)
int ism_head_get_version_int(ism_head *ismh)
{
  if (ism_head_is_image_shared_memory(ismh))
  {
    return((int)ismh->version);
  }
  return(-1);
}

// ism̃o[W`FbNBG[FALSE
int ism_head_check_ism_version(ism_head *ismh, uint16 version)
{
  if (ismh == NULL) return(FALSE);
  if (ism_head_is_image_shared_memory(ismh))
  {
    return(ismh->version >= version);
  }
  return(FALSE);
}

// ssm_data  ism_headւ̃|C^ l
ism_head *ism_get_head_from_ssm(ssm_data *ssm)
{
  ism_head *ismh;
  if (ssm != NULL)
  {
    ismh = (ism_head *)(ssm->data); // IɃZbg
    // fprintf(stderr,"Debug : Version : %04x\n",ismh->ism_magic);
    if (ism_head_is_image_shared_memory(ismh))
    {
      // IDmFł̂ism_head̃AhXԂ
      return(ismh);
    }
  }
  return(NULL);
}

// ssm_dataism_headRs[ĎĂ
// pismhNULL̎Aism_headTCYmalloc(free̕Kv)
ism_head *ism_copy_head_from_ssm(ism_head *pismh, ssm_data *ssm)
{
  ism_head *ismh;
  ismh = ism_get_head_from_ssm(ssm);
  if (ismh != NULL)
  {
    if (pismh == NULL) pismh = xalloc(ism_head, 1);
    memcpy((void *)pismh, (void *)ismh, sizeof(ism_head));
    return(pismh);
  }
  return(NULL);
}

// ssmidism_head擾
// ism_head *ism_get_head_from_id(char id[])
// l邪Assm_dataĂ܂̂ism_headӖɂȂ
// قړ̑piƂism_data݂邩mF֐`ł
int ism_is_exist_image_shared_memory(char id[])
{
  ssm_data *ssm;
  ism_head *ismh;

  ismh = NULL;
  if (is_exist_shared_memory(id))
  {
    ssm = alloc_shared_memory(id, sizeof(ism_head), SSM_READONLY);
    ismh = ism_get_head_from_ssm(ssm);
    free_shared_memory(ssm);
  }
  return(ismh != NULL);
}

// idism_headRs[ĎĂ
// pismhNULL̎Aism_headTCYmalloc
ism_head *ism_copy_head_from_id(ism_head *pismh, char id[])
{
  ssm_data *ssm;
  ism_head *ret;

  ret = NULL;
  if (is_exist_shared_memory(id))
  {
    ssm = alloc_shared_memory(id, sizeof(ism_head), SSM_READONLY);
    if (ssm == NULL) return(NULL);
    ret = ism_copy_head_from_ssm(pismh, ssm);
    free_shared_memory(ssm);
  }
  return(ret);
}

// ism_datahead,data,buffeȑ
// ֐ƂĒ`AO͎gȂ
static void ism_init_data_param(ism_data *ism)
{
  ism_head *ismh;
  char *d;

  ismh = (ism_head *)(ism->ssm.data);
  ism->head = ismh;
  d = (char *)ismh;
  d = d + ismh->offset;
  ism->data = (void *)d;
  ism->buffer = xalloc(char, ismh->maxsize);
  if (ism->buffer == NULL)
  {
    printf_error("Warning : Can't allocate memory for ism->buffer");
  }
}

// ism_datãm(ism_datałȂꍇNULLԂ)
ism_data *ism_get_image_shared_memory(char id[])
{
  ism_head ismh;
  ism_data *ism;

  if (ism_copy_head_from_id(&ismh, id) != NULL)
  {
    ism = xalloc(ism_data, 1);
    alloc_shared_memory_set(&(ism->ssm),
      id, ismh.offset + ismh.maxsize, SSM_READWRITE);
    ism_init_data_param(ism);
  }
  return(NULL);
}

// TCYw肵ism̃m
// (ism݂ȂꍇłTCYL̏ꍇVK쐬)
ism_data *ism_alloc_image_shared_memory(char id[],
  uint16 width,
  uint16 height,
  ism_color_mode ism_color)
{
  uint32 size;
  ism_head ismh_new, *ismh;
  int exist_flag;
  ssm_data *ssm;
  ism_data *ism;

  if (ism_color >= ISM_MAX) ism_color = ISM_RGB;

  // shared memorymہE邱ƂŁA{ɎQƃ[̏ꍇł
  ssm = alloc_shared_memory(id, (uint64)sizeof(ism_head),
    SSM_READONLY);
  if (ssm != NULL) free_shared_memory(ssm);

  // shared memoryxő݂Ă邩肷
  exist_flag = is_exist_shared_memory(id);
  if (exist_flag)
  {
    // shared memoryǂݏopŊmۂĂ݂
    ssm = alloc_shared_memory(id, (uint64)sizeof(ism_head),
      SSM_READONLY);
    if (ssm == NULL)
    {
      printf_error("ERROR : Can't allocate shared memoy.");
      return(NULL);
    }
    else
    {
      ismh = ism_get_head_from_ssm(ssm); // ɑ݂Ăssm𔻒肷
      if (ismh == NULL)
      {
	printf_error("ERROR : Shared memoy exists, "
	  "but is not image shared memory.");
	free_shared_memory(ssm);
	return(NULL);
      }
      // łɑ݂ĂꍇA摜TCY`FbN
      if (width == 0) width = ismh->width;
      if (height == 0) height = ismh->height;
      if ((width != ismh->width) || (height != ismh->height))
      {
	printf_error("ERROR : Incorrect size of Image shared memory"
		     "try(%dx%d) exist(%dx%d)",
		     width, height, ismh->width, ismh->height);
	free_shared_memory(ssm);
	return(NULL);
      }
      free_shared_memory(ssm);
    }
  }
  // fprintf(stderr,"Debug -------------\n");
  // 摜TCYłȂ߃G[I
  if ((width == 0) || (height == 0))
  {
    printf_error("ERROR : Can't find Image shared memoy.\n");
    return(NULL);
  }

  // ߂ď
  memset(&ismh_new, 0x00, sizeof(ism_head)); // S[ŏ
  ismh_new.ism_magic = ISM_ID_MAGIC;
  ismh_new.version = ISM_VERSION;
  ismh_new.offset = (uint32)sizeof(ism_head);
  ismh_new.width = width;
  ismh_new.height = height;
  ismh_new.fourcc = ism_fourcc[ism_color];
  // FOURCCɂĉςɂĂǂǂƂ肠RGBŌvZ
  ismh_new.maxsize = (uint32)width * height * 3;
  ismh_new.datasize = ismh_new.maxsize;	// maxsizeɍ킹
  size = ismh_new.offset + ismh_new.maxsize;

  ismh = NULL;
  ism = xalloc(ism_data, 1);
  if (ism == NULL)
  {
    printf_error("ERROR : Can't allocate ism_data memory.");
    return(NULL);
  }
  if (alloc_shared_memory_set(&(ism->ssm), id, (uint64)size,
    SSM_READWRITE) == NULL)
  {
    printf_error("ERROR : Can't allocate shared memory.");
  }
  else
  {
    ismh = (ism_head *)(ism->ssm.data); // ɔ肵Ă̂ŋZbg
    if (exist_flag) // łɑ݂Ăꍇ
    {
      // 摜TCỸ`FbN
      if ((ismh->width != ismh_new.width)
	|| (ismh->height != ismh_new.height))
      {
	// 摜TCYقȂ̂ŃG[ɂ
	printf_error("ERROR : Image size mismatch. ism(%dx%d) set(%dx%d)",
	  ismh->width, ismh->height, ismh_new.width, ismh_new.height);
	ismh = NULL;
      }
      else if (ismh->fourcc != ismh_new.fourcc)
      {
	// 摜tH[}bg(fourcc)قȂ̂ŃG[ɂ
	printf_error("ism_data : ism fourcc mismatch. ism(0x%08lx) set(0x%08lx)",
	  ismh->fourcc, ismh_new.fourcc);
	ismh = NULL;
      }
    }
    else // VK쐬
    {
      memcpy((void *)ismh, (void *)&ismh_new, sizeof(ism_head));
    }
  }
  if (ismh == NULL) // G[
  {
    ism_free_image_shared_memory(ism);
    return(NULL);
  }
  ism_init_data_param(ism);
  return(ism);
}

void ism_free_image_shared_memory(ism_data *ism)
{
  if (ism == NULL) return;
  free_shared_memory_set(&(ism->ssm));
  if (ism->buffer != NULL) free(ism->buffer);
  free(ism);
  return;
}
//-------------------------------------------------------------
//ȉAism_headΏۂƂTu[`Q
//-------------------------------------------------------------
// FOURCC̃[hl
ism_color_mode ism_head_get_color_mode(ism_head *ismh)
{
  int i;
  if (ismh == NULL) return(0);
  for (i = 0; i < ISM_MAX; i++)
  {
    if (ism_fourcc[i] == ismh->fourcc) return(i);
  }
  return(ISM_MAX);
}

//-------------------------------------------------------------
//ȉAism_datał邱ƂȌł̃Tu[`Q
//-------------------------------------------------------------

#if 0
// gȂH
// ㉺]Rs[(Windowsł̂)
static void memcpy_r(unsigned char *dest, unsigned char *src, int len,
  int mx, int my)
{
  int xlen, y;
  unsigned char *d, *e;

  xlen = len / my;
  e = (unsigned char *)dest;
  d = (unsigned char *)src + xlen * my;
  for (y = 0; y < my; y++)
  {
    d = d - xlen;
    memcpy(e, d, xlen);
    e = e + xlen;
  }
  return;
}
#endif

// ism̐f[^Rs[(Rs[)
// *dstɂ͂炩ismh->maxsizẽmۂĂ邱ƁB
// memcpŷŁAWindows̏㉺]̂܂
void *ism_copy_data(void *dst, ism_data *ism)
{
  ism_head *ismh;
  void *src;

  if (dst == NULL) return(NULL);
  if (ism == NULL) return(NULL);
  ismh = ism_get_head(ism);
  if (ismh == NULL) return(NULL);
  src = ism_get_data(ism);
  if (src == NULL) return(NULL);
  if (ismh->datasize == 0) ismh->datasize = ismh->maxsize; // ̃oOΉ
  memcpy(dst, src, ismh->datasize);
  return(dst);
}

#if 0
// ism̐f[^Rs[(܂Windows̏㉺])
// *dstɂ͂炩ismh->maxsizẽmۂĂ邱ƁB
void *ism_copy_data(void *dst, ism_data *ism)
{
  ism_head *ismh;
  void *src;

  if (dst == NULL) return(NULL);
  if (ism == NULL) return(NULL);
  ismh = ism_get_head(ism);
  if (ismh == NULL) return(NULL);
  src = ism_get_data(ism);
  if (src == NULL) return(NULL);

  if (ism_head_get_color_mode(ismh) == ISM_RGB)
  {
    if (ism->buffer == NULL) ism->buffer = xalloc(char, ismh->maxsize);
    if (ism->buffer == NULL) return(NULL);

    memcpy(ism->buffer, src, ismh->datasize);
    memcpy_r(dst, ism->buffer, ismh->datasize, ismh->width, ismh->height);
  }
  else
  {
    memcpy(dst, src, ismh->datasize);
  }
  return(dst);
}
#endif

// ism̐f[^Zbg(Rs[)
// memcpy
void *ism_put_data(ism_data *ism, void *src, uint32 datasize)
{
  ism_head *ismh;
  void *dst;

  if (src == NULL) return(NULL);
  if (ism == NULL) return(NULL);
  ismh = ism_get_head(ism);
  if (ismh == NULL) return(NULL);
  dst = ism_get_data(ism);
  if (dst == NULL) return(NULL);
  if (datasize == 0UL) datasize = ismh->maxsize;
  memcpy(dst, src, datasize);
  ism_head_update_datasize(ismh, datasize);
  return(dst);
}

#if 0
// WindowsƂ̓ύXȂߖ
// ism̐f[^Zbg(܂Windows̏㉺])
// *dstɂ͂炩ismh->maxsizẽmۂĂ邱ƁB
void *ism_put_data(ism_data *ism, void *src, uint32 datasize)
{
  ism_head *ismh;
  void *dst;

  if (src == NULL) return(NULL);
  if (ism == NULL) return(NULL);
  ismh = ism_get_head(ism);
  if (ismh == NULL) return(NULL);
  dst = ism_get_data(ism);
  if (dst == NULL) return(NULL);
  if (datasize == 0UL) datasize = ismh->maxsize;

  if (ism_head_get_color_mode(ismh) == ISM_RGB)
  {
    if (ism->buffer == NULL) ism->buffer = xalloc(char, ismh->maxsize);
    if (ism->buffer == NULL) return(NULL);

    memcpy_r(ism->buffer, src, datasize, ismh->width, ismh->height);
    memcpy(dst, ism->buffer, datasize);
  }
  else
  {
    memcpy(dst, src, ismh->datasize);
  }
  ism_head_update_datasize(ismh, datasize);
  return(dst);
}
#endif

//-------------------------------------------------------------
// ism_time֌WTu[`
//-------------------------------------------------------------
/*
  قs_timeƓɂȂ\肾A邩ǂ͗vB
*/
// XV
void ism_time_init(ism_time *lasttime)
{
  if (lasttime == NULL) return;
  memset(lasttime, 0, sizeof(ism_time));
}

// ݎl
void ism_time_get_now_time(ism_time *lasttime)
{
  if (lasttime == NULL) return;
#ifdef __windows__
  GetSystemTimeAsFileTime(lasttime);
#else
  gettimeofday(lasttime, NULL);
#endif
}

// 2ism_timêǂ炪𔻒肷
// now  target ̎ TRUEԂ
// FꍇłTRUEԂ
int ism_time_is_future(ism_time *now, ism_time *target)
{
  if (now == NULL) return(TRUE);
  if (target == NULL) return(FALSE);

#ifdef __windows__
  if (target->dwHighDateTime > now->dwHighDateTime) return(TRUE);
  if (target->dwHighDateTime < now->dwHighDateTime) return(FALSE);

  if (target->dwLowDateTime < now->dwLowDateTime) return(FALSE);
  // if(target->dwLowDateTime > now->dwLowDateTime) return(TRUE);
#else
  if (target->tv_sec > now->tv_sec) return(TRUE);
  if (target->tv_sec < now->tv_sec) return(FALSE);

  if (target->tv_usec < now->tv_usec) return(FALSE);
  // if(target->tv_usec > now->tv_usec) return(TRUE);
#endif
  return(TRUE);
}

// 2ism_time̍vZ
// F__windows__A0.1ʕb̍ʕbɊۂ߂Ă邽߁A
// Ԃl~ωZĂƁA덷\B
uint32 ism_time_calc_diff_time(ism_time *tstart, ism_time *tend)
{
  uint32 tmp;
#ifdef __windows__
  uint64 tmp64;
#endif
  if (tstart == NULL) return(0UL);
  if (tend == NULL) return(0UL);
  if (!ism_time_is_future(tstart, tend)) return(0UL);
#ifdef __windows__
  // ꎞIɂł̒lɂȂȂ悤ɒӂ
  tmp64 = ((uint64)
    (tend->dwHighDateTime - tstart->dwHighDateTime) << 32)
    + tend->dwLowDateTime;
  tmp64 = tmp64 + 5 - tstart->dwLowDateTime;
  tmp = (uint32)tmp64 / 10; // FILETIME0.1ʕbPʂȂ̂10Ŋ
#else
  // ꎞIɂł̒lɂȂȂ悤ɒӂ
  tmp = (uint32)(tend->tv_sec - tstart->tv_sec) * 1000000UL
    + tend->tv_usec;
  tmp = tmp - tstart->tv_usec;
#endif
  return(tmp);
}

// ism_timew莞Ԑi߂(Pʃʕb)
void ism_time_add_time(ism_time *st, uint32 add_time)
{
  uint32 tmp;
#ifdef __windows__
  uint64 tmp64;

  tmp64 = (uint64)add_time * 10 // FILETIME0.1ʕbPʂȂ̂10{
    + (uint64)st->dwLowDateTime;
  tmp = tmp64 >> 32;
  st->dwHighDateTime += tmp;
  tmp = tmp64 & 0xffffffff;
  st->dwLowDateTime = tmp;
#else
  tmp = add_time / 1000000UL; // ʂ̊Z͐؂̂
  st->tv_sec += tmp;
  add_time -= 1000000UL * tmp;

  add_time += st->tv_usec;
  while (add_time >= 1000000UL)
  {
    st->tv_sec++;
    add_time -= 1000000UL;
  }
  st->tv_usec = add_time;
#endif
}

// ism_headāAf[^XVꂽǂ肷
int ism_head_is_refreshed(ism_head *ismh, ism_time *lasttime)
{
  if (ismh == NULL) return(FALSE);
  if (lasttime == NULL) return(FALSE);
  return(memcmp(&(ismh->uptime), lasttime, sizeof(ism_time)) != 0);
}

// f[^XVȂǂ肷
int ism_head_is_not_updated(ism_head *ismh, ism_time *lasttime)
{
  if (ismh == NULL) return(TRUE);
  if (lasttime == NULL) return(TRUE);
  return(memcmp(&(ismh->uptime), lasttime, sizeof(ism_time)) == 0);
}

// ŌɍXV(ism_time)l
ism_time *ism_head_get_lasttime(ism_head *ismh, ism_time *lasttime)
{
  if (ismh == NULL) return(NULL);
  if (lasttime == NULL) return(NULL);
  ism_time_copy(lasttime, &(ismh->uptime));
  return(lasttime);
}

// ism_headāAf[^XV܂ő҂
ism_time *ism_head_wait_refresh(ism_head *ismh, ism_time *lasttime)
{
  if (ismh == NULL) return(NULL);
  if (lasttime == NULL) return(NULL);
  while (memcmp(&(ismh->uptime), lasttime, sizeof(ism_time)) == 0)
  {
    msleep(ISM_WAIT_UPDATE_MSEC);
  }
  ism_time_copy(lasttime, &(ismh->uptime));
  return(lasttime);
}

//-------------------------------------------------------------
// ism_head̓e̍XV
//-------------------------------------------------------------
// ism_headf[^XV(0NULLƍXVȂ)
void ism_head_update(ism_head *ismh, uint32 datasize, ism_time *lasttime)
{
  if (ismh == NULL) return;
  if (datasize != 0) ismh->datasize = datasize;
  if (lasttime != NULL) ism_time_copy(&(ismh->uptime), lasttime);
}

// ݎōXV
void ism_head_update_now(ism_head *ismh, uint32 datasize)
{
  ism_time lasttime;
  ism_time_get_now_time(&lasttime);
  ism_head_update(ismh, datasize, &lasttime);
}
