/*
  ism_data.h ism_data 𗘗p邽߂̊eTu[`
  o[WǗism_data.cŎ{B

  ȑOism_data.h́Aism_head.hɓƗAړB
*/
#ifndef __ISM_DATA_H__
#define __ISM_DATA_H__

#include "ism_head.h"

// ism_dataXṼEFCg(P:~b)
#define ISM_WAIT_UPDATE_MSEC	5
// 傫ƕׂႭȂ邪Aism_head_wait_refresh()݂̔ȂB
// u5v̎wł60fps(16.67~bԊu)炢܂ŒǏ]łH

// ism_time̕\(ʕbPʂ̕\)
#define ISM_TIME_DIV	1000000UL

// L(ssm_data)ɑ΂֐
// ̊֐ism_datał邩ۂۂɔfĂB
int ism_head_is_image_shared_memory(ism_head *ismh);
int ism_head_get_version_int(ism_head *ismh);
int ism_head_check_ism_version(ism_head *ismh,uint16 version);

// 擾łism_datał邪Aism_data\͍̂ȂB
ism_head *ism_get_head_from_ssm(ssm_data *ssm);
ism_head *ism_copy_head_from_ssm(ism_head *pismh,ssm_data *ssm);
// id璼ism_head()o
int ism_is_exist_image_shared_memory(char id[]);
// ism_get_head_from_id() ͍肽Iɕs\
// (ssm_dataĂ܂ism_headɂȂ)
ism_head *ism_copy_head_from_id(ism_head *pismh,char id[]);

// ism_data\
typedef struct {
  ssm_data ssm;		// 擪ssm_dataĂ
  ism_head *head;	// ism_head|C^̃Rs[(̒lssm_data)
  void *data;		// f[^|C^ւ̃Rs[(̒lssm_data)
  void *buffer;		// f[^ǂݏ̂߂̃obt@(NULL͖m)
} ism_data;

// ism_datač쐬֐
ism_data *ism_get_image_shared_memory(char id[]);
ism_data *ism_alloc_image_shared_memory(char id[],
					uint16 width,
					uint16 height,
					ism_color_mode ism_color);
void ism_free_image_shared_memory(ism_data *ism);

// RGBpismmۊ֐
#define ism_alloc_image_shared_memory_rgb(id,w,h)	\
  ism_alloc_image_shared_memory(id,w,h,ISM_RGB)

// ism_data  eo
#define ism_get_head(ism)	(ism_head *)((ism)==NULL?NULL:((ism)->head))
#define ism_get_data(ism)	(char *)((ism)==NULL?NULL:((ism)->data))
#define ism_get_buffer(ism)	(char *)((ism)==NULL?NULL:((ism)->buffer))

// ism_headɊւ֐(Ƀ}Nism_dataɂΉ)
#define ism_head_get_version(ismh)				\
  (float)((ismh)==NULL?0.0:1.0+(float)(ismh)->version/100.0)
#define ism_head_get_width(ismh)			\
  (uint16)((ismh)==NULL?0:(ismh)->width)
#define ism_head_get_height(ismh)			\
  (uint16)((ismh)==NULL?0:(ismh)->height)
#define ism_head_get_datasize(ismh)			\
  (uint32)((ismh)==NULL?0:(ismh)->datasize)
#define ism_head_get_maxsize(ismh)			\
  (uint32)((ismh)==NULL?0:(ismh)->maxsize)
ism_color_mode ism_head_get_color_mode(ism_head *ismh);

// ism_dataΉdefine
#define ism_get_version(ism)	ism_head_get_version(ism_get_head(ism))
#define ism_get_version_int(ism) ism_head_get_version_int(ism_get_head(ism))
#define ism_get_width(ism)	ism_head_get_width(ism_get_head(ism))
#define ism_get_height(ism)	ism_head_get_height(ism_get_head(ism))
#define ism_get_datasize(ism)	ism_head_get_datasize(ism_get_head(ism))
#define ism_get_maxsize(ism)	ism_head_get_maxsize(ism_get_head(ism))
#define ism_get_color_mode(ism)	ism_head_get_color_mode(ism_get_head(ism))

// 摜f[^̎oERs[֐
void *ism_copy_data(void *dst,ism_data *ism);

// 摜f[^̏݁ERs[֐
void *ism_put_data(ism_data *ism,void *src,uint32 datasize);

// ism_timeɊւ֐(s_timeƓe)
void ism_time_init(ism_time *lasttime);
void ism_time_get_now_time(ism_time *lasttime);
int ism_time_is_future(ism_time *now,ism_time *target);
uint32 ism_time_calc_diff_time(ism_time *tstart,ism_time *tend);
void ism_time_add_time(ism_time *st,uint32 add_time);

#define ism_time_copy(dst,src)	memcpy((dst),(src),sizeof(ism_time))

// ism_data̍XVAXV҂
int ism_head_is_refreshed(ism_head *ismh, ism_time *lasttime);
int ism_head_is_not_updated(ism_head *ismh, ism_time *lasttime);
ism_time *ism_head_get_lasttime(ism_head *ismh,ism_time *lasttime);
ism_time *ism_head_wait_refresh(ism_head *ismh,ism_time *lasttime);
// ism_dataΉdefine
#define ism_is_refreshed(ism,lasttime)			\
  ism_head_is_refreshed(ism_get_head(ism),lasttime)
#define ism_is_not_updated(ism,lasttime)		\
  ism_head_is_not_updated(ism_get_head(ism),lasttime)
#define ism_get_lasttime(ism,lasttime)			\
  ism_head_get_lasttime(ism_get_head(ism),lasttime)
#define ism_wait_refresh(ism,lasttime)			\
  ism_head_wait_refresh(ism_get_head(ism),lasttime)

// ismf[^XVɊւ֐
void ism_head_update(ism_head *ismh,
		     uint32 datasize, ism_time *lasttime);
void ism_head_update_now(ism_head *ismh, uint32 datasize);
#define ism_head_update_datasize(ismh,datasize)	\
  ism_head_update(ismh,datasize,NULL)
#define ism_head_update_time(ismh,lasttime)	\
  ism_head_update(ismh,(uint32)0,lasttime)
#define ism_head_update_time_now(ismh)		\
  ism_head_update_now(ismh,(uint32)0)
#define ism_head_update_datasize_now(ismh,datasize)	\
  ism_head_update_now(ismh,datasize)

// ism_dataΉdefine
#define ism_update(ism,datasize,lasttime)	\
  ism_head_update(ism_get_head(ism),datasize,lasttime)
#define ism_update_now(ism,datasize)			\
  ism_head_update_now(ism_get_head(ism),datasize)
#define ism_update_datasize(ism,datasize)	\
  ism_head_update_datasize(ism_get_head(ism),datasize)
#define ism_update_time(ism,lasttime)		\
  ism_head_update_time(ism_get_head(ism),lasttime)
#define ism_update_datasize_now(ism,datasize)	\
  ism_head_update_datasize_now(ism_get_head(ism),datasize)
#define ism_update_time_now(ism)		\
  ism_head_update_time_now(ism_get_head(ism))

/*
o[WƂ̌݊Ή
 ism_update(ism,datasize) --> ism_update_datasize_now(ism, datasize)
*/
#endif
