#ifndef __S_SHAREMEM_H__
#define __S_SHAREMEM_H__

#include	"s_windows.h"

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#ifdef __windows__
#include	<windows.h>
#else
#include	<machine/param.h>
#include	<sys/types.h>
#include	<sys/ipc.h>
#include	<sys/shm.h>
#endif

#ifdef __windows__
  /* none */
#else
// {͂̐ςĂʉ\ł͌Œ肷B
// Ƃ肠Cӂ̐ɂ(Ӗ͑SȂBꉞssm_̓Đ)
// int^Ȃ̂ŁAƂ肠l-32768`32767͈͓̔ɂ
#define NUM_ID		5561
#endif

typedef struct {
#ifdef __windows__
  HANDLE hSharedMem;
#else
  key_t key;
  int shrd_id;
#endif
  size_t size;
  void *data;
} ssm_data;

int is_exist_shared_memory(char id[]);
ssm_data *alloc_shared_memory_set(ssm_data *out,
				  char id[],unsigned long long size,int mode);
int free_shared_memory_force_set(ssm_data *ssm,int force_flag,int set_flag);

enum {	SSM_READWRITE=0,
	SSM_READONLY,
	SSM_WRITEONLY,
	SSM_MAX};

#define alloc_shared_memory(id,size,mode)	\
  alloc_shared_memory_set(NULL,id,size,mode)
#define alloc_shared_memory_rw(id,size)		\
  alloc_shared_memory(id,size,SSM_READWRITE)
#define alloc_shared_memory_r(id,size)		\
  alloc_shared_memory(id,size,SSM_READONLY)
#define alloc_shared_memory_w(id,size)		\
  alloc_shared_memory(id,size,SSM_WRITEONLY)
#define free_shared_memory(ssm)			\
  free_shared_memory_force_set(ssm,FALSE,FALSE)
#define free_shared_memory_force(ssm)		\
  free_shared_memory_force_set(ssm,TRUE,FALSE)
#define free_shared_memory_set(ssm)		\
  free_shared_memory_force_set(ssm,FALSE,TRUE)
#define free_shared_memory_set_force(ssm)	\
  free_shared_memory_force_set(ssm,TRUE,TRUE)

#endif
