/************************************************************************
 s_xachar 񃁃Tu[` Ver.1.06b
 ************************************************************************

v s_malloc,s_windows

 o
 Ver.1.00(2011/01/18)	s_mallocVer.105番
 Ver.1.01(2011/12/14)	NULLwł삷悤ɎdlύX
 Ver.1.02(2012/01/11)	r'\0'ꍇɑΉ
 Ver.1.03(2012/04/16)	xalloc_printf()֐ǉ
 Ver.1.04(2012/05/31)	xalloc_char_cat()֐ǉ
 Ver.1.05(2013/02/21)	WindowśAstring֌WWARNING΍
 Ver.1.06(2014/08/19)	va_list2gȂ悤ɕύX
*/
#include	<stdio.h>
#include	<stdlib.h>
#include	<stdarg.h>
#include	<string.h>

#include	"s_windows.h"
#include	"s_malloc.h"

/* 
   se̊Ԃ̕𐔂B
   strlenƈႢAŌNULL܂߂Ȃ̂Œ
*/
static int count_str(char *s,char *e)
{
  int len;
  
  if(s == NULL) return(0);
  if(e == NULL) e = strchr(s,'\0');
  len = 1;
  while((s < e) && (*s != '\0'))
    {
      s++; len++;
    }
  return(len);
}

/* ̊m */
char *xalloc_char(char data[])
{
  int len;
  char *point;

  point = NULL;
  if(data != NULL)
    {
      len = count_str(data,NULL);
      point = xalloc(char, len);
      if(point != NULL)
	{
	  if(len != 0)
	    memcpy (point, data, len);
	}
    }
  return(point);
}

/* 2̕ăm */
char *xalloc_char_cat(char data[],char data2[])
{
  int len;
  char *point;

  len = count_str(data,NULL) + count_str(data2,NULL);
  if((data != NULL) && (data2 != NULL)) len--;
  if(len == 0) return(NULL);
  point = xalloc(char,len);
  point[0] = '\0';
#ifdef __windows__
  if(data  != NULL) strcpy_s(point,len,data);
  if(data2 != NULL) strcat_s(point,len,data2);
#else
  if(data  != NULL) strcpy(point,data);
  if(data2 != NULL) strcat(point,data2);
#endif
  return(point);
}

char *xalloc_char_se(char start[], char end[])
{
  int len;
  char *point;

  if(start == NULL)return(NULL);
  if(end == NULL)return(xalloc_char(start));
  if(start > end)return(NULL);
  len = count_str(start,end);
  point = xalloc(char, len);
  len--;
  if(point != NULL)
    {
      if(len > 0) memcpy(point, start, len);
      point[len] = '\0';
    }
  return (point);
}

char *xalloc_vprintf(char *format, va_list argptr)
{
  int len;
  char *ret_code;
#ifndef __windows__
  va_list argptr2;
#endif

#ifdef __windows__
  len = _vscprintf(format,argptr) + 1;
#else
  va_copy(argptr2,argptr);
  len = vsnprintf(NULL,0,format,argptr2) + 1;
#endif
  ret_code = xalloc(char,len);
#ifdef __windows__
  vsnprintf_s(ret_code,len,_TRUNCATE,format,argptr);
#else
  vsnprintf(ret_code,len,format,argptr);
#endif
  return(ret_code);
}

char *xalloc_printf(char *format, ...)
{
  va_list argptr;
  char *ret_code;
  
  va_start(argptr, format);
  ret_code = xalloc_vprintf(format,argptr);
  va_end(argptr);
  return(ret_code);
}
